

import java.util.HashMap;
import java.util.Map;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.MapKey;
import javax.persistence.OneToMany;

@Entity
public class Department {
    @Id @GeneratedValue(strategy=GenerationType.IDENTITY)
    private int id;
    private String name;
    @OneToMany(mappedBy="department")
    @MapKey(name="name")
    private Map<String, Professor> employees;

    public Department() {
        employees = new HashMap<String, Professor>();
    }
    
    public int getId() {
        return id;
    }
    
    public void setId(int id) {
        this.id = id;
    }
    
    public String getName() {
        return name;
    }
    
    public void setName(String deptName) {
        this.name = deptName;
    }
    
    public void addProfessor(Professor employee) {
        if (!getProfessors().containsKey(employee.getName())) {
            getProfessors().put(employee.getName(), employee);
            if (employee.getDepartment() != null) {
                employee.getDepartment().getProfessors().remove(employee.getName());
            }
            employee.setDepartment(this);
        }
    }
    
    public Map<String,Professor> getProfessors() {
        return employees;
    }

    public String toString() {
        return "Department id: " + getId() + 
               ", name: " + getName();
    }
}
